<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
"use strict";
var gUser = {
        userName: "",
        firstName: "",
        lastName: "",
    }
const gBaseUrl = "http://42.115.221.44:8080/devcamp-lucky-dice/";
const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
const gREQUEST_STATUS_OK = 200;


    $("#btn-dice").click(function(){
        getDataFromFormToObject(gUser)
        if(validateDataObject(gUser)){
            callApi(gUser);
        }
    })
    function getDataFromFormToObject(paramUserObj){
        paramUserObj.userName = $("#inp-user-name").val();
        paramUserObj.firstName = $("#inp-first-name").val();
        paramUserObj.lastName = $("#inp-last-name").val();
    }
    function validateDataObject(paramUserObj){
        if(paramUserObj.userName == ""){
            alert("Chưa điền Username");
            return false;
        }
        if(paramUserObj.firstName == ""){
            alert("Chưa điền Firstname");
            return false;
        }
        if(paramUserObj.lastName == ""){
            alert("Chưa điền Lastname");
            return false;
        }
        return true;
    }
    function displayData(paramUserObj){
        console.log(paramUserObj);
    }
    function callApi(paramUserObj){
        const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
            // create a request
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", gBaseUrl + "/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", vUtf8TextApplicationHeader);
        vXmlHttpDice.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string

        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                console.log(vXmlHttpDice.responseText);
                var vResponse = JSON.parse(vXmlHttpDice.responseText);
                    console.log(vResponse);
                    // get result dice
                    var vDiceReady = vResponse.dice;
                    var vPrize = vResponse.prize
                    console.log("Dice result:= " + vDiceReady);
                    console.log("Prize:= " + vPrize);
                    //Hàm thay đổi dice
                    changeDice(vDiceReady);
                    //Hàm thay đổi thông báo
                    changeNotification(vDiceReady);
                    //Hàm gọi Voucher ID
                    changeVoucherId(vResponse);
                    //Hàm thay đổi ảnh quà tặng
                    changeGift(vResponse);
            }
        }
    }
    function changeDice(paramDice){
            "use strict";
            var vImgDice = $("#img-dice");
            switch(paramDice){
                case 1:
                    vImgDice.attr("src","LuckyDiceImages/1.png");
                    break;
                case 2:
                    vImgDice.attr("src","LuckyDiceImages/2.png");
                    break;
                case 3:
                    vImgDice.attr("src","LuckyDiceImages/3.png");
                    break;
                case 4:
                    vImgDice.attr("src","LuckyDiceImages/4.png");
                    break;
                case 5:
                    vImgDice.attr("src","LuckyDiceImages/5.png");
                    break;
                case 6:
                    vImgDice.attr("src","LuckyDiceImages/6.png");
                    break;
            }
        }
        function changeNotification(paramNotification){
            "use strict";
            var vNotification = $("#p-notification-dice");
            if (paramNotification < 4){
                vNotification.html("Xui quá, chơi lại đi");
                vNotification.attr("style","color:red");
            }
            else {
                vNotification.html("Hên quá, tiếp tục nào !");
                vNotification.attr("style","color:blue");
            }
        }
        function changeVoucherId(paramVoucherId){
            "use strict";
            var vPVoucherId = $("#p-voucher-id");
            var vPPhanTramGiamGia = $("#p-voucher-percent");
            if (paramVoucherId.voucher != null){
                vPVoucherId.html(paramVoucherId.voucher.maVoucher);
                vPPhanTramGiamGia.html(paramVoucherId.voucher.phanTramGiamGia + " %");
            }
            else{
                vPVoucherId.html(". . .");
                vPPhanTramGiamGia.html(". . .");
            }
        }
        function changeGift(paraGift){
            var vImgPresent = $("#img-present");
            var vTenPhanThuong =  paraGift.prize;
            switch(vTenPhanThuong){
                case "Mũ":
                    vImgPresent.attr("src","LuckyDiceImages/hat.jpg");
                        break;
                case "Áo":
                    vImgPresent.attr("src","LuckyDiceImages/t-shirt.jpg");
                        break;
                case "Xe máy":
                    vImgPresent.attr("src","LuckyDiceImages/xe-may.jpg");
                        break;
                case "Ô tô":
                    vImgPresent.attr("src","LuckyDiceImages/car.jpg");
                        break;
                default:
                    vImgPresent.attr("src","LuckyDiceImages/no-present.jpg");
                break;
            }
        }
</script>

</html>